commit 3bc4ed085145e1cb6089841c811094633eea7431
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Mon Sep 13 19:26:35 2021

    Fortran - fix handling of substring start and end indices
    
    gcc/fortran/ChangeLog:
    
            PR fortran/85130
            * expr.c (find_substring_ref): Handle given substring start and
            end indices as signed integers, not unsigned.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/85130
            * gfortran.dg/substr_6.f90: Revert commit r8-7574, adding again
            test that was erroneously considered as illegal.
    
    (cherry picked from commit 8d93ba93d3b13ac3d3c34404cad87732c809605b)

diff --git a/gcc/fortran/expr.c b/gcc/fortran/expr.c
index dfecc3012e1..604e63e6164 100644
--- a/gcc/fortran/expr.c
+++ b/gcc/fortran/expr.c
@@ -1724,8 +1724,8 @@ find_substring_ref (gfc_expr *p, gfc_expr **newp)
   *newp = gfc_copy_expr (p);
   free ((*newp)->value.character.string);
 
-  end = (gfc_charlen_t) mpz_get_ui (p->ref->u.ss.end->value.integer);
-  start = (gfc_charlen_t) mpz_get_ui (p->ref->u.ss.start->value.integer);
+  end = (gfc_charlen_t) mpz_get_si (p->ref->u.ss.end->value.integer);
+  start = (gfc_charlen_t) mpz_get_si (p->ref->u.ss.start->value.integer);
   if (end >= start)
     length = end - start + 1;
   else
diff --git a/gcc/testsuite/gfortran.dg/substr_6.f90 b/gcc/testsuite/gfortran.dg/substr_6.f90
index 0d5e3d75e88..83e788a55a6 100644
--- a/gcc/testsuite/gfortran.dg/substr_6.f90
+++ b/gcc/testsuite/gfortran.dg/substr_6.f90
@@ -6,6 +6,8 @@ CHARACTER(5), parameter :: c0(1) = (/ "123" // ACHAR(0) // "5" /)
 CHARACTER*5 c(1)
 CHARACTER(1), parameter :: c1(5) = (/ "1", "2", "3", ACHAR(0), "5" /)
 
+c = c0(1)(-5:-8)
+if (c(1) /= "     ") STOP 1
 c = (/ c0(1)(1:5) /)
 do i=1,5
    if (c(1)(i:i) /= c1(i)) STOP 2

